# AmazonBackupMySQLServerParameters Object

## Description

Parameters for the Amazon Backup MySQL Server action.

## Properties

### allDatabases

Specifies the options when backing up all databases. Required when `databases` is `all-databases`.

Type: [AllDatabases](/data-types/alldatabases-object.md) object

Required: Conditional

### amazonS3Target

Specifies the option when placing backups into Amazon S3. Required when `targetType` is `amazon-s3`.

Type: [AmazonS3Target](/data-types/amazons3target-object.md) object

Required: Conditional

### availabilityZone

Availability zone in which to launch the helper EC2 instance.

Type: `string`

Required: No

### credentialIds

Registered credentials to use with the action. One and only one credential must be specified.

Type: Array of `string`

Required: Yes

### databaseEndpoint

Endpoint information to connect to the server. Required when `endpointMethod` is `specify-endpoint`.

Type: [DatabaseEndpoint](/data-types/databaseendpoint-object.md) object

Required: Conditional

### databases

Indicates the databases to backup.

Type: `string`

Valid Values:

* `all-databases`
* `specific-databases`

Required: Yes

### endpointMethod

Method to use to retrieve connection information to connect to the server.

Type: `string`

Valid Values:

* `specify-endpoint`

Required: Yes

### engineVersion

Version of the backup engine to use. Unless otherwise instructed, use `version-2`.

Type: `string`

Valid Values:

* `version-1`
* `version-2`

Required: Yes

### extraCommandLineArguments

Extra command line arguments to add to the `mysqldump` command.

Type: `string`

Required: No

### instanceType

Instance type to use for the helper EC2 instance.

Type: `string`

Required: Yes

### isOmitDatabasesFlag

Indicates whether to omit the `--databases` flag from the `mysqldump` command line.

Type: `boolean`

Required: Yes

### privateIpAddress

Private IP address to assign to the helper EC2 instance.

Type: `string`

Required: No

### regionNames

Regions to use with the action. One and only one region must be specified.

Type: Array of `string`

Required: Yes

### securityGroup

Security group to attach to the helper EC2 instance. The security group should have permissions to connect to establish a connection with your MySQL server.

Type: `string`

Required: Yes

### specificDatabases

Specifies the specific database options to backup. Required when `databases` is `specific-databases`.

Type: [SpecificDatabases](/data-types/specificdatabases-object.md) object

Required: Conditional

### spotInstanceOptions

Use this field to specify options to use a spot instance for your helper EC2 instance.

Type: [SpotInstanceOptions](/data-types/spotinstanceoptions-object.md) object

Required: No

### subnetId

VPC subnet in which to launch the helper EC2 instance.

Type: `string`

Required: No

### targetType

Type of target to place the backups.

Type: `string`

Valid Values:

* `amazon-s3`

Required: Yes

### volumeSize

The default EBS volume size is 8 GB. If you require more, specify a larger EBS volume size.

Type: `integer`

Required: No

## Sample JSON

```javascript
{
    "credentialIds": [
        "cred-00000001"
    ],
    "regionNames": [
        "us-east-1"
    ],

    "engineVersion": "version-2",

    "instanceType": "t2.medium",
    "subnetId": "subnet-12345678",
    "securityGroup": "sg-12345678",
    "volumeSize": 30,

    "databases": "all-databases",
    "allDatabases": {
        "isSeparateDatabases": true
    },

    "endpointMethod": "specify-endpoint",
    "databaseEndpoint": {
        "endpoint": "mysql.example.com",
        "port": 3306,
        "username": "backup-user",
        "password": "pass123!",
    },

    "extraCommandLineArguments": "--single-transaction",
    "isOmitDatabasesFlag": false,

    "targetType": "amazon-s3",
    "amazonS3Target": {
        "bucketName": "my-backups",
        "objectKey": "backups/$(DATE)/$(DATABASE).sql.gz",
        "encryptionType": "aes256"
    }
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.skeddly.com/data-types/actionparameters-object/amazonbackupmysqlserverparameters-object.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
